// SVN_CreateExt.h : Declaration of the CSVN_CreateExt

#pragma once
#include "resource.h"       // main symbols
#include <comdef.h>         // Interface IDs
#include "svn_create.h"


// CSVN_CreateExt

class ATL_NO_VTABLE CSVN_CreateExt : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSVN_CreateExt, &CLSID_SVN_CreateExt>,
	public IDispatchImpl<ISVN_CreateExt, &IID_ISVN_CreateExt, &LIBID_svn_createLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IShellExtInit,
    public IContextMenu3
{
public:
	CSVN_CreateExt()
	{
	}


	// IContextMenu
	STDMETHOD(GetCommandString)(UINT, UINT, UINT*, LPSTR, UINT);
	STDMETHOD(InvokeCommand)(LPCMINVOKECOMMANDINFO);
	STDMETHOD(QueryContextMenu)(HMENU, UINT, UINT , UINT, UINT);

    // IContextMenu2
    STDMETHOD(HandleMenuMsg)(UINT, WPARAM, LPARAM);

    // IContextMenu3
    STDMETHOD(HandleMenuMsg2)(UINT, WPARAM, LPARAM, LRESULT*);

	// IShellExtInit
	STDMETHOD(Initialize)(LPCITEMIDLIST, LPDATAOBJECT, HKEY);

DECLARE_REGISTRY_RESOURCEID(IDR_SVN_CREATEEXT)


BEGIN_COM_MAP(CSVN_CreateExt)
	COM_INTERFACE_ENTRY(ISVN_CreateExt)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IShellExtInit)
	COM_INTERFACE_ENTRY(IContextMenu)
	COM_INTERFACE_ENTRY(IContextMenu2)
	COM_INTERFACE_ENTRY(IContextMenu3)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease();

public:
  // Helper functions for handling the menu-related messages.
    STDMETHOD(MenuMessageHandler)(UINT, WPARAM, LPARAM, LRESULT*);
    STDMETHOD(OnMeasureItem)(MEASUREITEMSTRUCT*, LRESULT*);
    STDMETHOD(OnDrawItem)(DRAWITEMSTRUCT*, LRESULT*);

	// Data
	TCHAR		m_szFile[MAX_PATH];
    UINT		m_uOurItemID;
	bool		m_bExtended;
	HBITMAP		m_hbmpUnchecked;

};

OBJECT_ENTRY_AUTO(__uuidof(SVN_CreateExt), CSVN_CreateExt)
